#!/usr/local/bin/perl

#===========================================================
# WwwBoard Ver 2.62
# Copyright (C) 1997-2001 Ƃق
# http://tohoho.wakusei.ne.jp/
# t[\tgEĔzz//p\EmF[sv
#===========================================================

#
# 1997.03.23 
# 2000.03.20 Ver2.61 V^bNX`FbN
# 2001.04.30 Ver2.62 ݒu̕ύX
#

#
# Maximum number of messages
#
$max_msgs = 100;

#
# Return URL
#
$return_url = "";

#
# Allow HTML tags
#
$allow_html = 0;

#
# Set timezone
#
$ENV{'TZ'} = "JST-9";

#
# Constant variables
#
@wdays = ( "", "", "", "", "", "", "y", "" );

#
# Test mode
#
if ($ARGV[0] eq "test") {
	print "Content-type: text/html\n";
	print "\n";
	print "<HTML>\n";
	print "<HEAD>\n";
	print "<TITLE>wwwboard test</TITLE>\n";
	print "</HEAD>\n";
	print "<BODY TEXT=black BGCOLOR=white>\n";
	print "CGIXNvg͐ɓ삵Ă܂B\n";
	if (! -d "lock") {
		print "<BR>NG. lockfBNg݂܂B\n";
	} elsif (! -w "lock") {
		print "<BR>NG. lockfBNgɏ݂ł܂B\n";
	} elsif (-d "lock/wwwboard.loc") {
		print "<BR>NG. lock/wwwboard.loc cĂ܂B\n";
	}
	if (! -f "wwwboard.dat") {
		print "<BR>NG. wwwboard.dat ݂܂B\n";
	} elsif (! -w "wwwboard.dat") {
		print "<BR>NG. wwwboard.dat ɏ݂ł܂B\n";
	}
	if (! -f "wwwboard.tmp") {
		print "<BR>NG. wwwboard.tmp ݂܂B\n";
	} elsif (! -w "wwwboard.tmp") {
		print "<BR>NG. wwwboard.tmp ɏ݂ł܂B\n";
	}
	print "</BODY>\n";
	print "</HTML>\n";
	exit(0);
}

#
# Japanese KANJI code
#
if (-f "jcode.pl") {
	$jflag = 1;
	require "jcode.pl";
	$code = ord(substr("", 0, 1));
	if ($code == 0xb4) {
		$ccode = "euc";
	} elsif ($code == 0x1b) {
		$ccode = "jis";
	} else {
		$ccode = "sjis";
	}
}

#
# Read variables
#
if ($ENV{'REQUEST_METHOD'} eq "POST") {
	read(STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
	@a = split(/&/, $query_string);
	foreach $x (@a) {
		($name, $value) = split(/=/, $x);
		$value =~ tr/+/ /;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		if ($jflag) {
			&jcode'convert(*value, "euc");
		}
		if ($allow_html) {
			$value =~ s/<!--/&lt;!--/g;
			$value =~ s/-->/--&gt;/g;
		} else {
			$value =~ s/&/&amp;/g;
			$value =~ s/"/&quot;/g;
			$value =~ s/</&lt;/g;
			$value =~ s/>/&gt;/g;
		}
		if ($jflag) {
			&jcode'convert(*value, $ccode);
		}
		$FORM{$name} = $value;
	}
}

#
# File lock
#
foreach $i ( 1, 2, 3, 4, 5, 6 ) {
	if (mkdir("lock/wwwboard.loc", 0755)) {
		last;
	} elsif ($i == 1) {
		($mtime) = (stat("lock/wwwboard.loc"))[9];
		if ($mtime < time() - 600) {
			rmdir("lock/wwwboard.loc");
		}
	} elsif ($i < 6) {
		sleep(2);
	} else {
		print "Content-type: text/html\n";
		print "\n";
		print "<HTML>\n";
		print "<HEAD>\n";
		print "<TITLE>f</TITLE>\n";
		print "</HEAD>\n";
		print "<BODY>\n";
		print "<H1>f</H1>\n";
		print "<HR>\n";
		print "AfGĂ܂B΂炭҂̏A";
		print "ēxANZX肢܂B\n";
		print "<HR>\n";
		print "</BODY>\n";
		print "</HTML>\n";
		exit(1);
	}
}

#
# Remove lockfile when terminated by signal
#
sub sigexit { rmdir("lock/wwwboard.loc"); exit(0); }
$SIG{'PIPE'} = $SIG{'INT'} = $SIG{'HUP'} = $SIG{'QUIT'} = $SIG{'TERM'} = "sigexit";

#
# Write to date file
#
if ($FORM{'MESSAGE'} ne "") {

	#
	# Get date and time
	#
	($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime(time);
	$date = sprintf("%04d/%02d/%02d(%s) %02d:%02d:%02d",
		$year + 1900, $mon + 1, $mday, $wdays[$wday],
		$hour, $min, $sec);

	#
	# Write current message.
	#
	$FORM{'MESSAGE'} =~ s/\r*$//g;
	$FORM{'MESSAGE'} =~ s/\r/<BR>/g;
	open(OUT, "> wwwboard.tmp");
	print OUT "<TABLE><TR><TD>\n";
	if ($FORM{'URL'} eq "") {
	    print OUT "<FONT COLOR=\"#FF0000\">$FORM{'FROM'}</FONT> $date\n";
	} elsif ($FORM{'URL'} =~ /^http:/) {
	    print OUT "<A HREF=\"$FORM{'URL'}\">$FORM{'FROM'}</A> $date\n";
	} else {
	    print OUT "<A HREF=\"mailto:$FORM{'URL'}\">$FORM{'FROM'}</A> $date\n";
	}
	print OUT "<BR>$FORM{'MESSAGE'}\n";
	print OUT "</TD></TR></TABLE>\n";
	print OUT "<HR>\n";

	#
	# Append messages.
	#
	open(IN, "wwwboard.dat");
	while (<IN>) {
		print OUT;
	}
	close(IN);
	close(OUT);

	#
	# Copy .tmp to .dat
	#
	open(IN, "wwwboard.tmp");
	open(OUT, "> wwwboard.dat");
	$msgs = 0;
	while (<IN>) {
		if ($_ =~ /^<TABLE><TR><TD>/) {
			if ($max_msgs != 0) {
				if ($msgs++ >= $max_msgs) {
					last;
				}
			}
		}
		print OUT;
	}
	close(IN);
	close(OUT);
}

#if ($ARGV[0] eq "reload") {
#	rmdir("lock/wwwboard.loc");
#	print "Location: $ENV{'SCRIPT_NAME'}\n";
#	print "\n";
#	exit(0);
#}

#
# Print HTML document
#
print "Content-type: text/html\n";
print "\n";
print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>f</TITLE>\n";
print "</HEAD>\n";
print "<BODY TEXT=black BGCOLOR=white>\n";
print "<H2>f</H2>\n";
if ($return_url ne "") {
	print "<A HREF=\"$return_url\">[߂]</A>\n";
}
print "<HR>\n";
#print "<FORM METHOD=POST ACTION=\"wwwboard.cgi?reload\">\n";
print "<FORM METHOD=POST ACTION=\"wwwboard.cgi\">\n";
print "<TABLE BORDER=1>\n";
print "<TR>";
print "<TD>OF</TD>";
print "<TD><INPUT TYPE=text NAME=FROM SIZE=54 VALUE=\"$FORM{'FROM'}\"></TD>\n";
print "</TR>\n";
print "<TR>";
print "<TD>tqkF</TD>";
print "<TD><INPUT TYPE=text NAME=URL SIZE=54 VALUE=\"$FORM{'URL'}\"></TD>";
print "</TR>\n";
print "<TR>";
print "<TD COLSPAN=2><SMALL>URLɂ̓[AhXAhttp:Ŏn܂z[y[WAhXĂBȗB</SMALL></TD>\n";
print "</TR>\n";
print "<TR><TD COLSPAN=2>";
print "<TEXTAREA ROWS=3 COLS=60 NAME=MESSAGE></TEXTAREA></TD></TR>\n";
print "</TABLE>\n";
print "<P><INPUT TYPE=submit VALUE=\"M / ēǂݍ\">\n";
print "</FORM>\n";
print "<HR>\n";
open(IN, "wwwboard.dat");
while (<IN>) {
	print;
}
close(IN);
print "</BODY>\n";
print "</HTML>\n";

#
# File unlock
#
rmdir("lock/wwwboard.loc");

